#include <iostream>

using std::endl;
using std::cout;

class ResourceGuard{
public:
  ResourceGuard(int i){
    myIntArray= new int[i];
    cout << "constructing of myIntArray: " << myIntArray  <<  endl;
  }
  ~ResourceGuard(){
    delete [] myIntArray;
    cout << "destruction of myIntArray: " << myIntArray <<  endl;
  }
private:
  int* myIntArray;
};

int main(){

  cout << endl;

  ResourceGuard resGuard(10000);

  cout << "\nbefore scope" << endl;

  {
    ResourceGuard resGuard2(200000);
  }
  cout << "after scope" << endl;

  cout << endl;

}


